/*
 * endatcli.c
 *
 *  Created on: Sep 7, 2012
 *      Author: serge
 */

#ifdef WIN32
#include "../../Interface_Library/msxe173x_modbus_clientlib.h"
#else
#include <msxe173x_modbus_clientlib.h>
#endif

#ifdef WIN32
#include <windows.h>
#define sleep Sleep
#define LONGLONG __int64
#else
#include <unistd.h>
#define LONGLONG long long
#endif // WIN32

#include <modbusclient.h>
#include <commonclient.h>

#include <addidata_network.h>

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPosition0(struct modbus * modbus, uint32_t * ulPositionLow, uint32_t * ulPositionHigh)
{
	int ret = 0;
	struct MSXE173x__EndatGetPosition0_parameters_t Response;

	/* Remote function call */
	ret = modbus_call_MSXE173x__EndatGetPosition0(modbus, &Response);

	/* Get position */
	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;

	/* Return value check */
	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPosition" );
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPosition1(struct modbus * modbus, uint32_t * ulPositionLow, uint32_t * ulPositionHigh)
{
	int ret = 0;
	struct MSXE173x__EndatGetPosition1_parameters_t Response;

	/* Remote function call */
	ret = modbus_call_MSXE173x__EndatGetPosition1(modbus, &Response);

	/* Get position */
	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;

	/* Return value check */
	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPosition" );
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPosition2(struct modbus * modbus, uint32_t * ulPositionLow, uint32_t * ulPositionHigh)
{
	int ret = 0;
	struct MSXE173x__EndatGetPosition2_parameters_t Response;

	/* Remote function call */
	ret = modbus_call_MSXE173x__EndatGetPosition2(modbus, &Response);

	/* Get position */
	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;

	/* Return value check */
	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPosition" );
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPosition3(struct modbus * modbus, uint32_t * ulPositionLow, uint32_t * ulPositionHigh)
{
	int ret = 0;
	struct MSXE173x__EndatGetPosition3_parameters_t Response;

	/* Remote function call */
	ret = modbus_call_MSXE173x__EndatGetPosition3(modbus, &Response);

	/* Get position */
	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;

	/* Return value check */
	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPosition" );
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatInitSensor(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulFrequency)
{
	/* variables declaration */
	int ret = 0;
	struct GetLastCommandStatus_parameters_t InitSensorStatus;

	/* Remote function call */
	ret = modbus_call_MSXE173x__EndatInitSensor(modbus, ulConnectorIndex, ulChannelIndex, ulFrequency, &InitSensorStatus);


	/* Return value check */
	return handle_result_of_FC16_query(modbus, &InitSensorStatus, ret, "modbus_call_MSXE173x__EndatInitSensor" );


}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPositionWithAddData0(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t *ulPositionLow, uint32_t *ulPositionHigh, uint32_t *ulAddData1, uint32_t *ulAddData2)
{
	/* Variables declaration */
	int ret = 0;
	struct MSXE173x__EndatGetPositionWithAddData0_parameters_t Response;

	ret = modbus_call_MSXE173x__EndatGetPositionWithAddData0(modbus, &Response);

	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;
	*ulAddData1 = Response.ulAddData1;
	*ulAddData2 = Response.ulAddData2;

	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPositionWithAddData0");
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPositionWithAddData1(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t *ulPositionLow, uint32_t *ulPositionHigh, uint32_t *ulAddData1, uint32_t *ulAddData2)
{
	/* Variables declaration */
	int ret = 0;
	struct MSXE173x__EndatGetPositionWithAddData1_parameters_t Response;

	ret = modbus_call_MSXE173x__EndatGetPositionWithAddData1(modbus, &Response);

	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;
	*ulAddData1 = Response.ulAddData1;
	*ulAddData2 = Response.ulAddData2;

	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPositionWithAddData1");
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPositionWithAddData2(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t *ulPositionLow, uint32_t *ulPositionHigh, uint32_t *ulAddData1, uint32_t *ulAddData2)
{
	/* Variables declaration */
	int ret = 0;
	struct MSXE173x__EndatGetPositionWithAddData2_parameters_t Response;

	ret = modbus_call_MSXE173x__EndatGetPositionWithAddData2(modbus, &Response);

	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;
	*ulAddData1 = Response.ulAddData1;
	*ulAddData2 = Response.ulAddData2;

	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPositionWithAddData2");
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatGetPositionWithAddData3(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t *ulPositionLow, uint32_t *ulPositionHigh, uint32_t *ulAddData1, uint32_t *ulAddData2)
{
	/* Variables declaration */
	int ret = 0;
	struct MSXE173x__EndatGetPositionWithAddData3_parameters_t Response;

	ret = modbus_call_MSXE173x__EndatGetPositionWithAddData3(modbus, &Response);

	*ulPositionLow = Response.ulPositionLow;
	*ulPositionHigh = Response.ulPositionHigh;
	*ulAddData1 = Response.ulAddData1;
	*ulAddData2 = Response.ulAddData2;

	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatGetPositionWithAddData3");
}

int sample_MSXE173x__EndatResetErrorBits(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex)
{
	int ret = 0;
	struct GetLastCommandStatus_parameters_t ResetErrorBitsStatus;

	ret = modbus_call_MSXE173x__EndatResetErrorBits(modbus, ulConnectorIndex, ulChannelIndex, &ResetErrorBitsStatus);

	return (handle_result_of_FC16_query(modbus, &ResetErrorBitsStatus, ret, "modbus_call_MSXE173x__EndatResetErrorBits"));
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatSelectMemoryArea(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulMrsCode)
{
	int ret = 0;
	struct GetLastCommandStatus_parameters_t SelectMemoryAreaStatus;

	ret = modbus_call_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, ulMrsCode, &SelectMemoryAreaStatus);

	return handle_result_of_FC16_query(modbus, &SelectMemoryAreaStatus, ret, "modbus_call_MSXE173x__EndatSelectMemoryArea");
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatSelectAdditionalData(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulAddDataCount, uint32_t ulMrsCodeAD1, uint32_t ulMrsCodeAD2)
{
	int ret = 0;

	struct GetLastCommandStatus_parameters_t SelectAdditionalDataStatus;

	ret = modbus_call_MSXE173x__EndatSelectAdditionalData(modbus, ulConnectorIndex, ulChannelIndex, ulAddDataCount, ulMrsCodeAD1, ulMrsCodeAD2, &SelectAdditionalDataStatus);

	return handle_result_of_FC16_query(modbus, &SelectAdditionalDataStatus, ret, "modbus_call_MSXE173x__EndatSelectAddData");
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatSensorReceiveParameter(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulMrsCode, uint32_t ulAddress, uint32_t ulParam)
{
	int ret = 0;

	struct GetLastCommandStatus_parameters_t ReceiveParameterStatus;

	ret = modbus_call_MSXE173x__EndatSensorReceiveParameter(modbus, ulConnectorIndex, ulChannelIndex, ulMrsCode, ulAddress, ulParam, &ReceiveParameterStatus);

	return handle_result_of_FC16_query(modbus, &ReceiveParameterStatus, ret, "modbus_call_MSXE173x__EndatSensorReceiveParameter");
}

int sample_MSXE173x__EndatGetErrorSources(struct modbus * modbus,
		uint32_t ulConnectorIndex,
		uint32_t ulChannelIndex,
		uint32_t * ulErrorSrc )
{
	int ret = 0;

	struct MSXE173x__EndatGetErrorSources0_parameters_t Response0;
	struct MSXE173x__EndatGetErrorSources1_parameters_t Response1;
	struct MSXE173x__EndatGetErrorSources2_parameters_t Response2;
	struct MSXE173x__EndatGetErrorSources3_parameters_t Response3;

	switch (ulConnectorIndex)
	{
	case 0:
		ret = modbus_call_MSXE173x__EndatGetErrorSources0(modbus, &Response0);
		*ulErrorSrc = Response0.ulErrorSrc;
		break;
	case 1:
		ret = modbus_call_MSXE173x__EndatGetErrorSources1(modbus, &Response1);
		*ulErrorSrc = Response1.ulErrorSrc;
		break;
	case 2:
		ret = modbus_call_MSXE173x__EndatGetErrorSources2(modbus, &Response2);
		*ulErrorSrc = Response2.ulErrorSrc;
		break;
	case 3:
		ret = modbus_call_MSXE173x__EndatGetErrorSources3(modbus, &Response3);
		*ulErrorSrc = Response3.ulErrorSrc;
		break;
	}
	return handle_result_of_FC3_query(modbus, ret, "sample_MSXE173x__EndatGetErrorSources");
}

//---------------------------------------------------------------------------------
int sample_MSXE173x__EndatSensorSendParameter(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulMrsCode, uint32_t ulAddress, uint32_t * ulParam)
{
	int ret = 0;
	struct MSXE173x__EndatModbusGetParameter0_parameters_t Response0;
	struct MSXE173x__EndatModbusGetParameter1_parameters_t Response1;
	struct MSXE173x__EndatModbusGetParameter2_parameters_t Response2;
	struct MSXE173x__EndatModbusGetParameter3_parameters_t Response3;

	struct GetLastCommandStatus_parameters_t SensorSendParameterStatus;
	ret = modbus_call_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, ulMrsCode, ulAddress, &SensorSendParameterStatus);

	ret = 0;
	switch(ulConnectorIndex)
	{
	case 0:
		ret = modbus_call_MSXE173x__EndatModbusGetParameter0(modbus, &Response0);
		*ulParam =Response0.ulParam;
		return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatModbusGetParameter");
		break;
	case 1:
		ret = modbus_call_MSXE173x__EndatModbusGetParameter1(modbus, &Response1);
		*ulParam =Response1.ulParam;
		break;
	case 2:
		ret = modbus_call_MSXE173x__EndatModbusGetParameter2(modbus, &Response2);
		*ulParam =Response2.ulParam;
		break;
	case 3:
		ret = modbus_call_MSXE173x__EndatModbusGetParameter3(modbus, &Response3);
		*ulParam =Response3.ulParam;
		break;
	}

	return handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE173x__EndatModbusGetParameter");
}


void exitSampleError(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex)
{
	int ret = 0;
	uint32_t ulErrorSrc = 0;

	printf("\n*********************************************************\n");
	/* Get the error */
	ret = sample_MSXE173x__EndatGetErrorSources(modbus, ulConnectorIndex, ulChannelIndex, &ulErrorSrc);
	if (ret != 0)
		printf("sample_MSXE173x__EndatGetErrorSources error : %d\n", ret);
	else
		printf("sample_MSXE173x__EndatGetErrorSources OK\n");

	if ((ret == 0) && (ulErrorSrc != 0))
	{
		/* Dump the errors */
		printf("error source 1  \t %d\n", (int) (ulErrorSrc & 1));
		printf("error source 2  \t %d\n", (int) ((ulErrorSrc >> 1) & 1));
		printf("error source 3  \t %d\n", (int) ((ulErrorSrc >> 2) & 1));
		printf("error source 4  \t %d\n", (int) ((ulErrorSrc >> 3) & 1));
		printf("error source 7  \t %d\n", (int) ((ulErrorSrc >> 4) & 1));
		printf("error source 8  \t %d\n", (int) ((ulErrorSrc >> 6) & 1));
		printf("error source 9  \t %d\n", (int) ((ulErrorSrc >> 7) & 1));
		printf("error source 10 \t %d\n", (int) ((ulErrorSrc >> 8) & 1));
		printf("error source 11 \t %d\n", (int) ((ulErrorSrc >> 9) & 1));
		printf("error source 12 \t %d\n", (int) ((ulErrorSrc >> 10) & 1));
		printf("error source 13 \t %d\n", (int) ((ulErrorSrc >> 11) & 1));
	}
	#ifdef WIN32
		while(!kbhit());
	#endif
		exit(1);
}


//---------------------------------------------------------------------------------
static void usage(char* name)
{
	printf("%s <IP ADDRESS> <tcp|udp> <sample> \n"
			" \n sample is defined like this :\n"
			" \t 0 : Digital I/O sample \n"
			" \t 1 : Reads the Endat position of a sensor\n "
			" \t 2 : Reads the Endat position of a sensor using additional data\n"
			" \t 3 : Reads/Writes in the OEM area of an EnDat sensor\n"
			" \t 4 : Get the operating status of an EnDat sensor\n"
			" \t 5 : Get Endat Parameter \n"
			" \t 6 : Set null position to sensor", name);
}


//---------------------------------------------------------------------------------
int sample_MSXE17xx__MSXE17xx__DigitalIOInitPort(struct modbus * modbus,
		uint32_t ulPort,
		uint32_t ulConfiguration)
{

	/* Variables declaration */

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;

	/* Remote function call */
	ret = modbus_call_MSXE17xx__DigitalIOInitPort(modbus,
			ulPort,
			ulConfiguration,
			&CommandStatus);

	/* Return value check */
	return handle_result_of_FC16_query(modbus, &CommandStatus, ret, "modbus_call_MSXE17xx__MSXE17xx__DigitalIOInitPort" );

}

//---------------------------------------------------------------------------------
int sample_MSXE17xx__DigitalIOTestShortCircuit(struct modbus * modbus,
		uint32_t *pulValue)
{
	/* Variables declaration */
	struct MSXE17xx__DigitalIOTestShortCircuit_parameters_t Response;
	int ret = 0;

	memset(&Response,0,sizeof(Response));

	ret = modbus_call_MSXE17xx__DigitalIOTestShortCircuit(modbus,
			&Response);


	if (handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE17xx__DigitalIOTestShortCircuit"))
	{
		return -1;
	}

	*pulValue  = Response.ulValue;

	return 0;
}

//---------------------------------------------------------------------------------
int sample_MSXE17xx__DigitalIOReadAllChannelsValue(struct modbus * modbus,
		uint32_t *pulValue)
{
	/* Variables declaration */
	struct MSXE17xx__DigitalIOReadAllChannelsValue_parameters_t Response;
	int ret = 0;

	memset(&Response,0,sizeof(Response));

	ret = modbus_call_MSXE17xx__DigitalIOReadAllChannelsValue(modbus,
			&Response);

	if (handle_result_of_FC3_query(modbus, ret, "modbus_call_MSXE17xx__DigitalIOReadAllChannelsValue"))
	{
		return -1;
	}

	*pulValue  = Response.ulChannelsValue;

	return 0;
}

//---------------------------------------------------------------------------------
int sample_MSXE17xx__DigitalIOWriteAllChannelsValue(struct modbus * modbus,
		uint32_t ulValue)
{
	/* Variables declaration */
	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;

	/* Remote function call */
	ret = modbus_call_MSXE17xx__DigitalIOWriteAllChannelsValue(modbus,
			ulValue,
			&CommandStatus);

	/* Return value check */
	return handle_result_of_FC16_query(modbus, &CommandStatus, ret, "modbus_call_MSXE17xx__DigitalIOWriteAllChannelsValue" );
}

/*
 * Display the memory area Space see p55/121 english endat specification for more informations
 */
void sampleDisplayAreaSpace(uint32_t areaIndex, uint32_t mask)
{
	int maskLow = 0;
	int maskHigh = 0;

	switch (mask & 0xF)
	{
	case 0:
		break;
	case 1:
		maskLow = 31;
		break;
	case 2:
		maskLow = 63;
		break;
	case 3:
		maskLow = 64;
		break;
	case 4:
		maskLow = 127;
		break;
	case 5:
		maskLow = 255;
		break;
	}

	switch ((mask >> 4) & 0xF)
	{
	case 0:
		break;
	case 1:
		maskHigh = 31;
		break;
	case 2:
		maskHigh = 63;
		break;
	case 3:
		maskHigh = 64;
		break;
	case 4:
		maskHigh = 127;
		break;
	case 5:
		maskHigh = 255;
		break;
	}

	if (mask == 0xFF)
	{
		printf("Area %lu : \t------\n", (unsigned long) areaIndex);
	}
	else
	{
		printf("Area %lu : \t %lu -> %lu\n", (unsigned long )areaIndex, (unsigned long) maskLow,(unsigned long)(maskHigh));
	}
}

/*
 * Enter the parameter for the sensor (module, channel and frequency)
 */
void sampleInitParameters(uint32_t * ulConnectorIndex, uint32_t * ulChannelIndex, uint32_t * ulFrequency)
{
	do
	{
		printf("Enter the index of the module you want to use (0->3) : ");
		scanf("%lu", (unsigned long *)ulConnectorIndex);
	}
	while (*ulConnectorIndex < 0 || *ulConnectorIndex > 3);

	*ulChannelIndex = 0;

	printf("Enter the frequency for the sensor : 500, 900, 1500, 2500, 4500 : ");
	scanf("%lu", (unsigned long *) ulFrequency);
}

/*
 * Get the position of the sensor
 */
void sampleGetPosition(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulFrequency)
{
	int ret = 0;

	uint32_t ulPositionLow 	= 0;
	uint32_t ulPositionHigh = 0;

	switch(ulConnectorIndex)
	{
	case 0: /* Only a sensor on input 0*/
		ret = sample_MSXE173x__EndatInitSensor(modbus, 0, 0, ulFrequency);
		if (ret != 0)
		{
			printf("sample_MSXE173x__EndatInitSensor error %d\n", ret);
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
		}
		else
			printf("sample_MSXE173x__EndatInitSensor OK\n");
		do
		{
			printf("Sensor input 0\n");
			ret = sample_MSXE173x__EndatGetPosition0 (modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPosition0 error %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE173x__EndatGetPosition0 OK\n");
			printf("Position Low  0 = %lu\n", (unsigned long)ulPositionLow);
			printf("Position High 0 = %lu\n\n", (unsigned long)ulPositionHigh);
			printf("To close the sample press space then enter key\nOther key to get again the position\n");
		}
		while(getchar() != 0x20);
		break;
	case 1:  /* Only a sensor on input 1*/
		ret = sample_MSXE173x__EndatInitSensor(modbus, 1, 0, ulFrequency);
		if (ret != 0)
		{
			printf("sample_MSXE173x__EndatInitSensor error %d\n", ret);
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
		}
		else
			printf("sample_MSXE173x__EndatInitSensor OK\n");
		do
		{
			printf("Sensor input 1\n");
			ret = sample_MSXE173x__EndatGetPosition1 (modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPosition1 error %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE173x__EndatGetPosition1 OK\n");
			printf("Position Low  1 = %lu\n", (unsigned long)ulPositionLow);
			printf("Position High 1 = %lu\n\n", (unsigned long)ulPositionHigh);
			printf("To close the sample press space then enter key\nOther key to get again the position\n");
		}
		while(getchar() != 0x20);
		break;
	case 2: /* Only a sensor on input 2*/
		ret = sample_MSXE173x__EndatInitSensor(modbus, 2, 0, ulFrequency);
		if (ret != 0)
		{
			printf("sample_MSXE173x__EndatInitSensor error %d\n", ret);
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
		}
		else
			printf("sample_MSXE173x__EndatInitSensor OK\n");
		do
		{
			printf("Sensor input 2\n");
			ret = sample_MSXE173x__EndatGetPosition2 (modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPosition2 error %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE173x__EndatGetPosition2 OK\n");
			printf("Position Low  2 = %lu\n", (unsigned long)ulPositionLow);
			printf("Position High 2 = %lu\n\n", (unsigned long)ulPositionHigh);
			printf("To close the sample press space then enter key\nOther key to get again the position\n");
		}
		while(getchar() != 0x20);
		break;
	case 3: /* Only a sensor on input 1 and 2*/
		ret = sample_MSXE173x__EndatInitSensor(modbus, 3, 0, ulFrequency);
		if (ret != 0)
		{
			printf("sample_MSXE173x__EndatInitSensor error %d\n", ret);
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
		}
		else
			printf("sample_MSXE173x__EndatInitSensor OK\n");
		do
		{
			printf("Sensor input 3\n");
			ret = sample_MSXE173x__EndatGetPosition3 (modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPosition3 error %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE173x__EndatGetPosition3 OK\n");

			printf("Position Low  1 = %lu\n", (unsigned long)ulPositionLow);
			printf("Position High 1 = %lu\n\n", (unsigned long)ulPositionHigh);
			printf("To close the sample press space then enter key\nOther key to get again the position\n");
		}
		while(getchar() != 0x20);
		break;
	}

}

/*
 * Get position of the sensor with 1 or 2 additional data
 */
void sampleGetPositionWithAddData(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulFrequency)
{
	int ret = 0;

	/* Get position variables*/
	uint32_t	  ulPositionLow 	= 0;
	uint32_t	  ulPositionHigh	= 0;
	uint32_t	  ulMrsCodeAD1		= 0;
	uint32_t	  ulMrsCodeAD2		= 0;

	/* Additional informations */
	uint32_t	  ulAddDataCount	= 0;
	uint32_t	  ulAddData1		= 0;
	uint32_t	  ulAddData2		= 0;

	printf("get position with additional data \n");

	/* Init the sensor */
	ret = sample_MSXE173x__EndatInitSensor(modbus, ulConnectorIndex, ulChannelIndex, ulFrequency );
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatInitSensor error %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatInitSensor OK\n");

	do
	{
		printf("select the number of additional data you want :");
		scanf("%lX", (unsigned long *)&ulAddDataCount);
	}
	while (ulAddDataCount<0 || ulAddDataCount>2);
	if(ulAddDataCount == 1)
	{
		do
		{
			printf("select the mrsCodeAI1 (0x40 -> 0x4E), make sure that additional data is available with your sensor");
			scanf("%lX", (unsigned long *)&ulMrsCodeAD1);
		}
		while (ulMrsCodeAD1 < 0x40 || ulMrsCodeAD1 > 0x4E);
	}
	else if (ulAddDataCount == 2)
	{
		do
		{
			printf("select the mrsCodeAI1 (0x40 -> 0x4E), make sure that additional data is available with your sensor");
			scanf("%lX", (unsigned long*) &ulMrsCodeAD1);
		}
		while (ulMrsCodeAD1 < 0x40 || ulMrsCodeAD1 > 0x4E);
		do
		{
			printf("select the mrsCodeAI2 (0x50 -> 0x5B), make sure that additional data is available with your sensor");
			scanf("%lX", (unsigned long *)&ulMrsCodeAD2);
		}
		while (ulMrsCodeAD2 < 0x50 || ulMrsCodeAD2 > 0x5B);
	}
	else
	{
		ulMrsCodeAD1 = 0;
		ulMrsCodeAD2 = 0;
	}
	ret = sample_MSXE173x__EndatSelectAdditionalData(modbus, ulConnectorIndex, ulChannelIndex, ulAddDataCount, ulMrsCodeAD1, ulMrsCodeAD2);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSelectAdditionalData error %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSelectAdditionalData OK\n");
	do{
		switch(ulConnectorIndex)
		{
		case 0:
			ret = sample_MSXE173x__EndatGetPositionWithAddData0(modbus, ulConnectorIndex, ulChannelIndex, &ulPositionLow, &ulPositionHigh, &ulAddData1, &ulAddData2);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPositionWithAddData0 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			break;
		case 1:
			ret = sample_MSXE173x__EndatGetPositionWithAddData1(modbus, ulConnectorIndex, ulChannelIndex, &ulPositionLow, &ulPositionHigh, &ulAddData1, &ulAddData2);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPositionWithAddData1 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			break;
		case 2:
			ret = sample_MSXE173x__EndatGetPositionWithAddData2(modbus, ulConnectorIndex, ulChannelIndex, &ulPositionLow, &ulPositionHigh, &ulAddData1, &ulAddData2);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPositionWithAddData2 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			break;
		case 3:
			ret = sample_MSXE173x__EndatGetPositionWithAddData3(modbus, ulConnectorIndex, ulChannelIndex, &ulPositionLow, &ulPositionHigh, &ulAddData1, &ulAddData2);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatGetPositionWithAddData3 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			break;
		}
		printf("PositionLow : %lu\nPositionHigh :%lu\nAddData1 : %lu\nAddData2 : %lu\n\n", (unsigned long)ulPositionLow, (unsigned long)ulPositionHigh, (unsigned long)ulAddData1, (unsigned long)ulAddData2);
		printf("To close the sample press space then enter key\nOther key to get again the position\n");
	}
	while(getchar() != 0x20);
}

/*
 * Read or write memory on the EnDat sensor
 */
void sampleReadWriteOEM(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulFrequency)
{
	int ret = 0;
	uint32_t ulParam12 		 	= 0;
	uint32_t ulParam34			 = 0;

	uint32_t ulErrorSrc			= 0;

	/* Init the sensor */
	ret = sample_MSXE173x__EndatInitSensor(modbus, ulConnectorIndex, ulChannelIndex, ulFrequency );
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatInitSensor error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatInitSensor OK\n");

	/* Select the memory area A1 */
	ret = sample_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, 0xA1);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSelectMemoryArea error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSelectMemoryArea OK\n");

	/* Read the address 0x9 (contain addresses for area 1 and area 2) */
	ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xA1, 0x9, &ulParam12);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorSendParameter error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorSendParameter OK\n");

	sampleDisplayAreaSpace(1, ulParam12 & 0xFF);
	sampleDisplayAreaSpace(2, (ulParam12>>8 & 0xFF));

	/* Read the address 0xA (contain addresses for area 2 and area 3) */
	ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xA1, 0xA, &ulParam34);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorSendParameter error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorSendParameter OK\n");

	sampleDisplayAreaSpace(3, ulParam34 & 0xFF);
	sampleDisplayAreaSpace(4, (ulParam34>>8 & 0xFF));

	for(;;)
	{
		char ulKey;
		int checked = 0;
		uint32_t ulWriteParameter;
		printf("Hit 'r' to read a parameter of the OEM, 'w' to write a parameter of the OEM, Space then enter to exit\n");
		do
		{
			scanf("%c", (char *) &ulKey);
			if(ulKey == 'r')
			{
			    checked = 1;
			}
			else if (ulKey == 'w')
			{
				checked = 1;
			}
			else if (ulKey == 32)
			{
			  checked = 1;
			}
			else
			{
			  checked = 0;
			}
		}
		while(checked == 0);
		if (ulKey == 32)
		{
			break;
		}
		if (ulKey == 'r')
		{
			ulWriteParameter = 0;
		}
		if (ulKey == 'w')
		{
			ulWriteParameter = 1;
		}
		if (ulWriteParameter == 0)
		{
			uint32_t ulOemArea = 0;
			uint32_t ulAddress = 0;
			uint32_t ulMrsCode = 0;
			uint32_t ulValue = 0;

			do
			{
				printf("Enter the area that you want to use  : \n");
				scanf("%lu", (unsigned long *)&ulOemArea);
			}
			while((ulOemArea < 1) || (ulOemArea > 4));
			printf ("Valid address space: \n");

			switch (ulOemArea)
			{
			case 1:

				sampleDisplayAreaSpace(1, (ulParam12 & 0xFF));
				ulMrsCode = 0xA9;
				break;
			case 2:
				sampleDisplayAreaSpace(2, (ulParam12>>8) & 0xFF);
				ulMrsCode = 0xAB;
				break;
			case 3:
				sampleDisplayAreaSpace(3, ulParam34 & 0xFF);
				ulMrsCode = 0xAD;
				break;
			case 4:
				sampleDisplayAreaSpace(4, (ulParam34>>8) & 0xFF);
				ulMrsCode = 0xAF;
				break;
			}

			/* Select the memory area */
			ret = sample_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, ulMrsCode);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatSelectMemoryArea error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE173x__EndatSelectMemoryArea (0x%X): OK\n", ulMrsCode);

			printf("Enter the address that you want to read (must be in address space) : \n");
			scanf("%lu", (unsigned long *)&ulAddress);

			/* Then read the content */
			ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, ulMrsCode, ulAddress, &ulValue);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatSensorSendParameter error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}

			printf("Value : 0x%X \n", ulValue);
		}

		/* User want to write */
		if (ulWriteParameter == 1)
		{
			uint32_t ulOemArea = 0;
			uint32_t ulAddress = 0;
			uint32_t ulMrsCode = 0;
			uint32_t ulValue = 0;

			do
			{
				printf ("Enter the parameters of the OEM's you want to set (1->4) :\n");
				scanf("%d", &ulOemArea);
			}
			while(ulOemArea < 1 || ulOemArea > 4);

			switch (ulOemArea)
			{
			case 1:
				sampleDisplayAreaSpace(1, ulParam12 & 0xFF);
				ulMrsCode = 0xA9;
				break;
			case 2:
				sampleDisplayAreaSpace(2, ulParam12>>8);
				ulMrsCode = 0xAB;
				break;
			case 3:
				sampleDisplayAreaSpace(3, ulParam34 & 0xFF);
				ulMrsCode = 0xAD;
				break;
			case 4:
				sampleDisplayAreaSpace(4, ulParam34>>8);
				ulMrsCode = 0xAF;
				break;
			}

			/* Select the memory area */
			ret = sample_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, ulMrsCode);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatSelectMemoryArea error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE173x__EndatSelectMemoryArea (0x%X): OK\n", ulMrsCode);

			printf("EndatSelectMemoryArea (0x%X): ok \n", ulMrsCode);

			printf("Enter the address that you want to set (must be in the address space) : \n");
			scanf("%lu", (unsigned long *)&ulAddress);

			printf("Enter the new value :");
			scanf("%lu", (unsigned long *)&ulValue);

			/* Then set the content */
			ret = sample_MSXE173x__EndatSensorReceiveParameter(modbus, ulConnectorIndex, ulChannelIndex, ulMrsCode, ulAddress, ulValue);
			if (ret != 0)
			{
				printf("sample_MSXE173x__EndatSensorReceiveParameter error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE173x__EndatSensorReceiveParameter (0x%X - %d): OK\n", ulMrsCode, ulAddress);
		}

		printf("\n****************************************************************************\n");

		/* Get the error */
		ret = sample_MSXE173x__EndatGetErrorSources(modbus, ulConnectorIndex, ulChannelIndex, &ulErrorSrc);
		if (ret != 0)
		{
			printf("sample_MSXE173x__EndatGetErrorSources error : %d\n", ret);
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
		}
		else
			printf("sample_MSXE173x__EndatGetErrorSources OK\n");
	}
}

/*
 * Get the operating status of the system
 */
void sampleGetOperatingStatus(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulFrequency)
{
	int ret = 0;
	uint32_t ulParam;

	uint32_t ulErrorSrc			= 0;

	printf("sampleGetOperatingStatus");

	/* init the sensor */
	ret = sample_MSXE173x__EndatInitSensor(modbus, ulConnectorIndex, ulChannelIndex, ulFrequency );
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatInitSensor error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatInitSensor OK\n");

	/* Reset the error bits */
	ret = sample_MSXE173x__EndatResetErrorBits(modbus, ulConnectorIndex, ulChannelIndex);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatResetErrorBits error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatResetErrorBits OK\n");

	/**
	 * Select the memory area 0xB9
	 * Indeed, in the EnDat documentation, you can see that the memory area 0xB9 contains information
	 * Concerning the operating status
	 */
	ret = sample_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, 0xB9);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSelectMemoryArea error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSelectMemoryArea OK\n");

	printf("\n*********************************************************\n");
	/* Read the word 0 (error message) - MRS-Code (0xB9) stay the same */
	ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xB9, 0x0, &ulParam);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorReceiveParameter error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorReceiveParameter (0xB9 - 0x0) OK\n");

	printf("sample_MSXE173x__EndatSensorSendParameter (0xB9 - 0x0 ): ok. \n");
	printf("Error message (read in the sensor's register) : 0x%x \n", ulParam);
	if ( (ulParam & 1) == 1 )
	{
		printf("\tLight source: Failure.\n");
	}
	if ( ((ulParam >> 1) & 1) == 1 )
	{
		printf("\tSignal amplitude: Faulty.\n");
	}
	if ( ((ulParam >> 2) & 1) == 1 )
	{
		printf("\tPosition: Faulty.\n");
	}
	if ( ((ulParam >> 3) & 1) == 1 )
	{
		printf("\tOvervoltage: Yes.\n");
	}
	if ( ((ulParam >> 4) & 1) == 1 )
	{
		printf("\tUndervoltage: Undervoltage supply.\n");
	}
	if ( ((ulParam >> 5) & 1) == 1 )
	{
		printf("\tOvercurrent: Yes.\n");
	}
	if ( ((ulParam >> 6) & 1) == 1 )
	{
		printf("\tBattery: Change required.\n");
	}

	/* Reset the error bits of the operating status */
	ret = sample_MSXE173x__EndatSensorReceiveParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xB9, 0x0, 0x0);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorReceiveParameter error : %d", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorReceiveParameter (0xB9 - 0x0) OK\n");

	printf("\n*********************************************************\n");
	/* Read the word 1 (warnings) - MRS-Code (0xB9) stay the same */
	ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xB9, 0x1, &ulParam);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorSendParameter error : %d", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorSendParameter (0xB9 - 0x1) OK\n");

	printf("sample_MSXE173x__EndatSensorSendParameter (0xB9 - 0x1 ): ok. \n");

	printf("Warnings (read in the sensor's register) : 0x%x \n", ulParam);
	if ( (ulParam & 1) == 1 )
	{
		printf("\tFrequency collision: Yes.\n");
	}
	if ( ((ulParam >> 1) & 1) == 1 )
	{
		printf("\tTemperature exceeded: Yes.\n");
	}
	if ( ((ulParam >> 2) & 1) == 1 )
	{
		printf("\tLight source control reserve: Reached.\n");
	}
	if ( ((ulParam >> 3) & 1) == 1 )
	{
		printf("\tBattery charge: Too low.\n");
	}
	if ( ((ulParam >> 4) & 1) == 1 )
	{
		printf("\tReference points: Not reached.\n");
	}
	if ( ((ulParam >> 5) & 1) == 1 )
	{
		printf("\tCyclic mode: Acyclic.\n");
	}
	if ( ((ulParam >> 6) & 1) == 1 )
	{
		printf("\tLimit position: Reached.\n");
	}
	if ( ((ulParam >> 7) & 1) == 1 )
	{
		printf("\tReadiness: None.\n");
	}
	if ( ((ulParam >> 8) & 1) == 1 )
	{
		printf("\tDiagnostics: Below threshold value.\n");
	}

	/* Reset the warnings bits of the operating status */
	ret = sample_MSXE173x__EndatSensorReceiveParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xB9, 0x1, 0x0);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorReceiveParameter error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorReceiveParameter (0xB9 - 0x1) OK\n");

	printf("i_PCIe1711_EndatSensorReceiveParameter (0xB9 - 0x1 ): ok. \n");

	printf("\n*********************************************************\n");
	/* Read the word 2 (write-protected status) - MRS-Code (0xB9) stay the same */
	ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xB9, 0x2, &ulParam);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorSendParameter error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorSendParameter (0xB9 - 0x2) OK\n");

	printf("Write-protected status (read in the sensor's register) : 0x%x \n", ulParam);
	if ( (ulParam & 1) == 1 )
	{
		printf("\tEncoder manufacturer: Protection activated.\n");
	}
	if ( ((ulParam >> 1) & 1) == 1 )
	{
		printf("\tOperating parameters: Protection activated.\n");
	}
	if ( ((ulParam >> 2) & 1) == 1 )
	{
		printf("\tOEM: Protection activated.\n");
	}
	if ( ((ulParam >> 3) & 1) == 1 )
	{
		printf("\tCompensation values, MRS code 10110111: Protection activated.\n");
	}
	if ( ((ulParam >> 4) & 1) == 1 )
	{
		printf("\tCompensation values, MRS code 10110101: Protection activated.\n");
	}
	if ( ((ulParam >> 5) & 1) == 1 )
	{
		printf("\tCompensation values, MRS code 10110011: Protection activated.\n");
	}
	if ( ((ulParam >> 6) & 1) == 1 )
	{
		printf("\tSection 2 memory area block 0: Protection activated.\n");
	}
	if ( ((ulParam >> 7) & 1) == 1 )
	{
		printf("\tSection 2 memory area block 1: Protection activated.\n");
	}
	if ( ((ulParam >> 8) & 1) == 1 )
	{
		printf("\tSection 2 memory area block 2: Protection activated.\n");
	}
	if ( ((ulParam >> 9) & 1) == 1 )
	{
		printf("\tSection 2 memory area block 3 to n: Protection activated.\n");
	}

	printf("\n*********************************************************\n");
	/* Read the word 3 (initializing the Functions) - MRS-Code (0xB9) stay the same */
	ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xB9, 0x3, &ulParam);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorSendParameter error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSensorSendParameter (0xB9 - 0x3) OK\n");

	printf("Initializing the Functions (read in the sensor's register) : 0x%x \n", ulParam);
	if ( (ulParam & 1) == 1 )
	{
		printf("\tRecovery time tm: 1.25us < tm < 3.75us.\n");
	}
	else
	{
		printf("\tRecovery time tm: 10us < tm < 30us.\n");
	}
	if ( ((ulParam >> 2) & 1) == 1 )
	{
		printf("\tReference pulse initialization: Activated.\n");
	}
	else
	{
		printf("\tReference pulse initialization: Deactivated.\n");
	}
	if ( ((ulParam >> 4) & 1) == 1 )
	{
		printf("\tOversampling: Activated.\n");
	}
	else
	{
		printf("\tOversampling: Deactivated.\n");
	}
	if ( ((ulParam >> 6) & 1) == 1 )
	{
		printf("\tEnDat 2.2 cyclic operation: Activated.\n");
	}
	else
	{
		printf("\tEnDat 2.2 cyclic operation: Deactivated.\n");
	}
	if ( ((ulParam >> 8) & 1) == 1 )
	{
		printf("\tMultiturn overflow error message: Activated.\n");
	}
	else
	{
		printf("\tMultiturn overflow error message: Deactivated.\n");
	}
	if ( ((ulParam >> 9) & 1) == 1 )
	{
		printf("\tMultiturn overflow latch: Activated.\n");
	}
	else
	{
		printf("\tMultiturn overflow latch: Deactivated.\n");
	}
	if ( ((ulParam >> 10) & 1) == 1 )
	{
		printf("\tMultiturn error messages: Activated.\n");
	}
	else
	{
		printf("\tMultiturn error messages: Deactivated.\n");
	}
	if ( ((ulParam >> 11) & 1) == 1 )
	{
		printf("\tMultiturn counter reset: Activated.\n");
	}
	else
	{
		printf("\tMultiturn counter reset: Deactivated.\n");
	}
	if ( ((ulParam >> 13) & 1) == 1 )
	{
		printf("\tDiagnostics reset: Activated.\n");
	}
	else
	{
		printf("\tDiagnostics reset: Deactivated.\n");
	}

	printf("\n*********************************************************\n");
	/* Get the error */
	ret = sample_MSXE173x__EndatGetErrorSources(modbus, ulConnectorIndex, ulChannelIndex, &ulErrorSrc);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatGetErrorSources error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatGetErrorSources OK\n");

	printf("EndatGetErrorSources: ok. \n");
}

/*
 * Sample to set null point from actual position
 */
void sampleDatumShiftSetNullPointToActualPosition(struct modbus * modbus, uint32_t ulConnectorIndex, uint32_t ulChannelIndex, uint32_t ulFrequency)
{
	int       i                   = 0;
	int       ret                 = 0;
	uint32_t  param               = 0;
	LONGLONG  llActualDatumShift  = 0;
	LONGLONG  llNewDatumShift     = 0;
	uint32_t  ulPositionLow       = 0;
	uint32_t  ulPositionHigh      = 0;

	/* Init sensor */
	ret = sample_MSXE173x__EndatInitSensor(modbus, ulConnectorIndex, ulChannelIndex, ulFrequency);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatInitSensor error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatInitSensor OK\n");

	/* Select opening parameters memory area in order to acces to datum shift register */
	ret = sample_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, 0xA7);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSelectMemoryArea error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSelectMemoryArea OK\n\n");

	printf("Datum shift actual value (words 0 to 2):\n");

	/* Get datum shift (word 0 to 2) */
	for (i = 0; i< 3; i++)
	{
		ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xA7, i, &param);
		if (ret != 0)
		{
			printf("sample_MSXE173x__EndatSensorSendParameter error : %d\n", ret);
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
		}
		/* Print actual word value */
		printf("\tWord %d value = 0x%x\n", i, param);

		/* Compute 48 bit datum shift */

		llActualDatumShift += ((LONGLONG)param << (i * 16));
	}
	/* Get the 2 complement */
	llActualDatumShift = (~llActualDatumShift);

	/* Get the sensor position in order to set the null point at this position */
	switch (ulConnectorIndex)
	{
		case 0:
			ret = sample_MSXE173x__EndatGetPosition0(modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("\nsample_MSXE170x__EndatGetPosition0 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("\nsample_MSXE170x__EndatGetPosition0 OK\n");
			break;
		case 1:
			ret = sample_MSXE173x__EndatGetPosition1(modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("sample_MSXE170x__EndatGetPosition1 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE170x__EndatGetPosition1 OK\n");
			break;
		case 2:
			ret = sample_MSXE173x__EndatGetPosition2(modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("sample_MSXE170x__EndatGetPosition2 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE170x__EndatGetPosition2 OK\n");
			break;
		case 3:
			ret = sample_MSXE173x__EndatGetPosition3(modbus, &ulPositionLow, &ulPositionHigh);
			if (ret != 0)
			{
				printf("sample_MSXE170x__EndatGetPosition3 error : %d\n", ret);
				exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			}
			else
				printf("sample_MSXE170x__EndatGetPosition3 OK\n");
			break;
		default:
			printf("Wrong ulConnectorIndex \n");
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
			break;
	}

	/* Compute new datum shift */
	llNewDatumShift = ulPositionLow + ((LONGLONG)ulPositionHigh << 32) + llActualDatumShift;

	/* Select opening parameters memory area */
	ret = sample_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, 0xA7);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSelectMemoryArea error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSelectMemoryArea OK\n\n");

	/* Get the two complement and build a 48 bits word */
	llNewDatumShift = ~llNewDatumShift;

	printf("Datum shift new value (words 0 to 2):\n");

	/* Write datum shift (word 0 to 2)  */
	for (i = 0; i< 3; i++)
	{

		ret = sample_MSXE173x__EndatSensorReceiveParameter(modbus, ulConnectorIndex, ulChannelIndex, 0xA7, i, (uint32_t)(llNewDatumShift >> (i * 16)) & 0xFFFF);
		if (ret != 0)
		{
			printf("\nsample_MSXE173x__EndatSensorReceiveParameter error : %d\n", ret);
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
		}
		printf("\tWord %d = 0x%llx\n", i, (llNewDatumShift >> (i * 16)) & 0xFFFF);
	}

	printf("\n");

	/* Sensor reset */
	{
		struct GetLastCommandStatus_parameters_t ResetSensorStatus;

		ret = modbus_call_MSXE173x__EndatSensorReceiveReset(modbus, ulConnectorIndex, ulChannelIndex, &ResetSensorStatus);

		if (handle_result_of_FC16_query(modbus, &ResetSensorStatus, ret, "modbus_call_MSXE173x__EndatResetErrorBits") != 0)
			exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);

		printf("modbus_call_MSXE173x__EndatSensorReceiveReset OK\n");
	}

	return;
}

/*
 * Function to use the digital IO
 */
void sampleDigiIO(struct modbus * modbus)
{
	int i 				= 0;
	int ret             = 0;
	uint32_t ulValue	= 0;

	for (i = 0; i < 8; i ++)
	{
		ret = sample_MSXE17xx__MSXE17xx__DigitalIOInitPort(modbus, i, 1);
		if (ret != 0)
		{
			printf("sample_MSXE17xx__MSXE17xx__DigitalIOInitPort error : %d\n", ret);
#ifdef WIN32
			while(!kbhit());
#endif
			exit(1);
		}
		else
			printf("sample_MSXE17xx__MSXE17xx__DigitalIOInitPort OK\n");
	}


	for (i = 0; i < 64; i ++)
	{
		ret = sample_MSXE17xx__DigitalIOWriteAllChannelsValue(modbus, 1 << (i % 16));
		if (ret != 0)
		{
			printf("sample_MSXE17xx__DigitalIOWriteAllChannelsValue error : %d\n", ret);
#ifdef WIN32
			while(!kbhit());
#endif
			exit(1);
		}
		else
			printf("sample_MSXE17xx__DigitalIOWriteAllChannelsValue OK\n");

		ret = sample_MSXE17xx__DigitalIOReadAllChannelsValue(modbus, &ulValue);
		if (ret != 0)
		{
			printf("sample_MSXE17xx__DigitalIOReadAllChannelsValue error : %d\n", ret);
#ifdef WIN32
			while(!kbhit());
#endif
			exit(1);
		}
		else
			printf("sample_MSXE17xx__DigitalIOReadAllChannelsValue OK\n");

		printf ("I/O state = %xHex\n", ulValue);
		sleep  (250);
	}

	for (i = 0; i < 8; i ++)
	{
		ret = sample_MSXE17xx__MSXE17xx__DigitalIOInitPort(modbus, i, 0);
		if (ret != 0)
		{
			printf("sample_MSXE17xx__MSXE17xx__DigitalIOInitPort error : %d\n", ret);
#ifdef WIN32
			while(!kbhit());
#endif
			exit(1);
		}
		else
			printf("sample_MSXE17xx__MSXE17xx__DigitalIOInitPort OK\n");
	}

	for (i = 0; i < 100; i ++)
	{
		ret = sample_MSXE17xx__DigitalIOReadAllChannelsValue(modbus,&ulValue);
			if (ret != 0)
			{
				printf("sample_MSXE17xx__DigitalIOReadAllChannelsValue error : %d\n", ret);
#ifdef WIN32
			while(!kbhit());
#endif
			exit(1);
			}
			else
				printf("sample_MSXE17xx__DigitalIOReadAllChannelsValue OK\n");
		printf ("I/O state = %xHex\n", ulValue);

		sleep  (100);
	}
}

void sampleGetSensorParameter(struct modbus *modbus, uint32_t ulConnectorIndex,uint32_t ulChannelIndex, uint32_t ulFrequency)
{
	int      ret          = 0;
	uint32_t param        = 0;
	uint32_t memoryArea   = 0;
	uint32_t paramAddress = 0;

	/* Get memory parameter */
	do
	{
		printf("Enter the memory area of the sensor you want to read in hexadecimal fomat (ex: A1) : ");
		scanf("%lx", (unsigned long *)&memoryArea);
	}
	while (memoryArea != 0xA1
	  &&   memoryArea != 0xA3
	  &&   memoryArea != 0xA5
	  &&   memoryArea != 0xA7
	  &&   memoryArea != 0xA9
	  &&   memoryArea != 0xAB
	  &&   memoryArea != 0xAD
	  &&   memoryArea != 0xAF
	  &&   memoryArea != 0xB1
	  &&   memoryArea != 0xB3
	  &&   memoryArea != 0xB5
	  &&   memoryArea != 0xB7
	  &&   memoryArea != 0xB9);

	/* Get address parameter */
	do
	{
		printf("Enter the address of the parameter you want to read (depends on memory area selected): ");
		scanf("%lu", (unsigned long *)&paramAddress);
	}
	while (paramAddress > 256);

	/* Init sensor */
	ret = sample_MSXE173x__EndatInitSensor(modbus, ulConnectorIndex, ulChannelIndex, ulFrequency);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatInitSensor error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatInitSensor OK\n");

	/* Select opening parameters memory area */
	ret = sample_MSXE173x__EndatSelectMemoryArea(modbus, ulConnectorIndex, ulChannelIndex, memoryArea);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSelectMemoryArea error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}
	else
		printf("sample_MSXE173x__EndatSelectMemoryArea OK\n\n");

	/* Get sensor parameter */
	ret = sample_MSXE173x__EndatSensorSendParameter(modbus, ulConnectorIndex, ulChannelIndex, memoryArea, paramAddress, &param);
	if (ret != 0)
	{
		printf("sample_MSXE173x__EndatSensorSendParameter error : %d\n", ret);
		exitSampleError(modbus, ulConnectorIndex, ulChannelIndex);
	}

	printf("\nResults :\n\tMemory Area: 0x%x \n\tParam address: %d \n\tParam value in decimal: %d\n\tParam value in hexadecimal: 0x%x\n", memoryArea, paramAddress, param, param);

	return;
}

/* This program allows to use the digital I/O and EnDat functionalities of the MSX-E1731 system.
 * The application takes 3 parameters in input: The IP addres, the connection mode (udp or tcp) and an index of sample
 * The following indexes are available for the sample:
 * - 0: Digital I/O sample
 * - 1: Reads the Endat position of a sensor
 * - 2: Reads the Endat position of a sensor using additional data
 * - 3: Reads/Writes in the OEM area of an EnDat sensor
 * - 4: Get the operating status of an EnDat sensor
 */
int main(int argc, char** argv)
{
	int contype = 0;
	uint32_t ulConnectorIndex = 0;
	uint32_t ulChannelIndex = 0;
	uint32_t ulFrequency = 0;
	struct modbus modbus;

	/* check the input parameters */
	if (argc < 4)
	{
		usage(argv[0]);
		exit(1);
	}

	/* check the connection type */
	if (0 == strcmp(argv[2],"tcp"))
		contype=SOCK_STREAM;
	else if(0 == strcmp(argv[2],"udp"))
		contype=SOCK_DGRAM;
	else
	{
		usage(argv[0]);
		exit(1);
	}

	modbus_init(&modbus);

	switch( modbus_connect(&modbus,argv[1], contype, 0) )
	{
		case 0: /* success */
			break;
		case -1: /* system error */
			addidata_network_perror("modbus_connect");
			exit(1);
		case -2: /* parameter is incorrect */
			printf("modbus_connect: incorrect parameter\n");
			exit(1);
		case -3: /* incorrect address */
			printf("incorrect address\n");
			exit(1);
	}

	/* Reset errors */
	sample_MSXE173x__EndatResetErrorBits(&modbus, 0, 0);
	sample_MSXE173x__EndatResetErrorBits(&modbus, 1, 0);
	sample_MSXE173x__EndatResetErrorBits(&modbus, 2, 0);
	sample_MSXE173x__EndatResetErrorBits(&modbus, 3, 0);

	/* Selection of the sample */
	if ( atoi(argv[3]) == 0 )
	{
		sampleDigiIO(&modbus);
	}
	else if ( atoi(argv[3]) == 1 )
	{
		/* init parameter (module, channel, frequency) */
		sampleInitParameters(&ulConnectorIndex,
				&ulChannelIndex,
				&ulFrequency);
		/* Launch the sample */
		sampleGetPosition(&modbus,
				ulConnectorIndex,
				ulChannelIndex,
				ulFrequency);
	}
	else if ( atoi(argv[3]) == 2 )
	{
		/* init parameter (module, channel, frequency) */
		sampleInitParameters(&ulConnectorIndex,
				&ulChannelIndex,
				&ulFrequency);
		/* Launch the sample */
		sampleGetPositionWithAddData(&modbus,
				ulConnectorIndex,
				ulChannelIndex,
				ulFrequency);
	}
	else if ( atoi(argv[3]) == 3 )
	{
		/* init parameter (module, channel, frequency) */
		sampleInitParameters(&ulConnectorIndex,
				&ulChannelIndex,
				&ulFrequency);
		/* Launch the sample */
		sampleReadWriteOEM(&modbus,
				ulConnectorIndex,
				ulChannelIndex,
				ulFrequency);
	}
	else if ( atoi(argv[3]) == 4 )
	{
		/* init parameter (module, channel, frequency) */
		sampleInitParameters(&ulConnectorIndex,
				&ulChannelIndex,
				&ulFrequency);
		/* Launch the sample */
		sampleGetOperatingStatus(&modbus,
				ulConnectorIndex,
				ulChannelIndex,
				ulFrequency);
	}
	else if ( atoi(argv[3]) == 5 )
	{
		/* init parameter (module, channel, frequency) */
		sampleInitParameters(&ulConnectorIndex,
				&ulChannelIndex,
				&ulFrequency);
		/* Launch the sample */
		sampleDatumShiftSetNullPointToActualPosition(&modbus,
				ulConnectorIndex,
				ulChannelIndex,
				ulFrequency);
	}
	else if ( atoi(argv[3]) == 6 )
	{
		/* init parameter (module, channel, frequency) */
		sampleInitParameters(&ulConnectorIndex,
				&ulChannelIndex,
				&ulFrequency);
		/* Launch the sample */
		sampleGetSensorParameter(&modbus,
				ulConnectorIndex,
				ulChannelIndex,
				ulFrequency);
	}
	return 0;
}
